/*******************************************************************************
 * Copyright (c) 2010-2013 Torsten Hildebrandt and jasima contributors
 *
 * This file is part of jasima, v1.0.
 *
 * jasima is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * jasima is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with jasima.  If not, see <http://www.gnu.org/licenses/>.
 *
 * $Id: TimeWeightedSummaryStat.java 74 2013-01-08 17:31:49Z THildebrandt@gmail.com $
 *******************************************************************************/
package jasima.core.statistics;

/**
 * Summary stat which weights values according to the time.
 * 
 * @author Torsten Hildebrandt <hil@biba.uni-bremen.de>
 * @version "$Id: TimeWeightedSummaryStat.java 74 2013-01-08 17:31:49Z THildebrandt@gmail.com $"
 */
public class TimeWeightedSummaryStat extends SummaryStat {
	private static final long serialVersionUID = -2192851354158356984L;

	private double lastTime = 0.0d;

	@Override
	public void value(double value, double time) {
		super.value(lastValue, time - lastTime);
		lastTime = time;
		lastValue = value;
	}

}
